- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- NOTES
- HISTORY
- SEE ALSO
- COPYRIGHT

# NAME

SSL_CTX_set_max_send_fragment, SSL_set_max_send_fragment, SSL_CTX_set_split_send_fragment, SSL_set_split_send_fragment, SSL_CTX_set_max_pipelines, SSL_set_max_pipelines, SSL_CTX_set_default_read_buffer_len, SSL_set_default_read_buffer_len - Control fragment sizes and pipelining operations

# SYNOPSIS

     #include <openssl/ssl.h>

     long SSL_CTX_set_max_send_fragment(SSL_CTX *ctx, long);
     long SSL_set_max_send_fragment(SSL *ssl, long m);

     long SSL_CTX_set_max_pipelines(SSL_CTX *ctx, long m);
     long SSL_set_max_pipelines(SSL_CTX *ssl, long m);

     long SSL_CTX_set_split_send_fragment(SSL_CTX *ctx, long m);
     long SSL_set_split_send_fragment(SSL *ssl, long m);

     void SSL_CTX_set_default_read_buffer_len(SSL_CTX *ctx, size_t len);
     void SSL_set_default_read_buffer_len(SSL *s, size_t len);

# DESCRIPTION

Some engines are able to process multiple simultaneous crypto operations. This capability could be utilised to parallelise the processing of a single connection. For example a single write can be split into multiple records and each one encrypted independently and in parallel. Note: this will only work in TLS1.1+. There is no support in SSLv3, TLSv1.0 or DTLS (any version). This capability is known as "pipelining" within OpenSSL.

In order to benefit from the pipelining capability. You need to have an engine that provides ciphers that support this. The OpenSSL "dasync" engine provides AES128-SHA based ciphers that have this capability. However these are for development and test purposes only.

SSL_CTX_set_max_send_fragment() and SSL_set_max_send_fragment() set the max_send_fragment parameter for SSL_CTX and SSL objects respectively. This value restricts the amount of plaintext bytes that will be sent in any one SSL/TLS record. By default its value is SSL3_RT_MAX_PLAIN_LENGTH (16384). These functions will only accept a value in the range 512 - SSL3_RT_MAX_PLAIN_LENGTH.

SSL_CTX_set_max_pipelines() and SSL_set_max_pipelines() set the maximum number of pipelines that will be used at any one time. This value applies to both "read" pipelining and "write" pipelining. By default only one pipeline will be used (i.e. normal non-parallel operation). The number of pipelines set must be in the range 1 - SSL_MAX_PIPELINES (32). Setting this to a value > 1 will also automatically turn on "read_ahead" (see SSL_pending(3)).

The SSL_CTX_set_default_read_buffer_len() and SSL_set_default_read_buffer_len() functions control the size of the read buffer that will be used. The len parameter sets the size of the buffer. The value will only be used if it is greater than the default that would have been used anyway. The normal default value depends on a number of factors but it will be at least SSL3_RT_MAX_PLAIN_LENGTH + SSL3_RT_MAX_ENCRYPTED_OVERHEAD (16704) bytes.

# RETURN VALUES

All non-void functions return 1 on success and 0 on failure.

# NOTES

With the exception of SSL_CTX_set_default_read_buffer_len() and SSL_set_default_read_buffer_len() all these functions are implemented using macros.

# HISTORY

The SSL_CTX_set_max_pipelines(), SSL_set_max_pipelines(), SSL_CTX_set_split_send_fragment(), SSL_set_split_send_fragment(), SSL_CTX_set_default_read_buffer_len() and SSL_set_default_read_buffer_len() functions were added in OpenSSL 1.1.0.

# SEE ALSO

SSL_pending(3)

# COPYRIGHT

Copyright 2016 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.